<Query Kind="Program">
  <Reference>&lt;RuntimeDirectory&gt;\System.Runtime.Serialization.dll</Reference>
  <Reference>C:\Utils\LINQPad\References\Azure SDK 1.6\Microsoft.ServiceBus.dll</Reference>
  <Namespace>Microsoft.ServiceBus</Namespace>
  <Namespace>Microsoft.ServiceBus.Messaging</Namespace>
</Query>

void Main()
{
	#region "Secret Stuff"
		string issuer = "{ACSIssuer}";
		string key = "{ACSIssuerKey}";
	#endregion
	
	TokenProvider tP = TokenProvider.CreateSharedSecretTokenProvider(issuer, key);
	Uri uri = ServiceBusEnvironment.CreateServiceUri("sb", "{ServiceBusNamespaceName}", string.Empty);
	
	string endPointName = "TestQueue";
	
	//string endPointName = "TestTopic/subscriptions/demoSub";
	//string endPointName = "TestTopic/subscriptions/demoFilteredSub";
	
	MessagingFactory factory = MessagingFactory.Create(uri, tP);
	MessageReceiver receiver = factory.CreateMessageReceiver(endPointName);

	// Continuously process messages sent to the "TestQueue" 
	while (true)
	{
		using (BrokeredMessage message = receiver.Receive(TimeSpan.FromSeconds(10)))
		{
			if (message != null)
			{
				try
				{
					Console.WriteLine("Body: " + message.GetBody<string>());
					Console.WriteLine("MessageID: " + message.MessageId);
					Console.WriteLine("Custom Property: " + message.Properties["MessageCount"]);
					// Remove message from queue
					message.Complete();
				}
				catch (Exception)
				{
					// Indicate a problem, unlock message in queue
					message.Abandon();
				}
			} 
			else {
				Console.WriteLine("No Messages");
			}
		}
	}
}