<Query Kind="Program">
  <Reference>&lt;RuntimeDirectory&gt;\System.Runtime.Serialization.dll</Reference>
  <Reference>C:\Utils\LINQPad\References\Azure SDK 1.6\Microsoft.ServiceBus.dll</Reference>
  <Namespace>Microsoft.ServiceBus</Namespace>
  <Namespace>Microsoft.ServiceBus.Messaging</Namespace>
</Query>

void Main()
{
	#region "Secret Stuff"
		string issuer = "{ACSIssuer}";
		string key = "{ACSIssuerKey}";
	#endregion
	
	TokenProvider tP = TokenProvider.CreateSharedSecretTokenProvider(issuer, key);
	Uri uri = ServiceBusEnvironment.CreateServiceUri("sb", "{ServiceBusNamespaceName}", string.Empty);
	
	string endPointName = "TestSessionQueue";
	
	MessagingFactory factory = MessagingFactory.Create(uri, tP);
	QueueClient client = factory.CreateQueueClient(endPointName);
	while (true)
	{
		MessageSession session = client.AcceptMessageSession();
		Console.WriteLine("Message Session Started: " + session.SessionId);
		while (!session.IsClosed)
		{
			using (BrokeredMessage message = session.Receive(TimeSpan.FromSeconds(10)))
			{
				if (message != null)
				{
					try
					{
						Console.WriteLine("Body: " + message.GetBody<string>());
						Console.WriteLine("MessageID: " + message.MessageId);
						Console.WriteLine("Custom Property: " + message.Properties["MessageCount"]);
						Console.WriteLine("SessionID:" + message.SessionId);
						
						if (message.Properties["MessageCount"].ToString() == "3" && message.DeliveryCount < 8)
						{
							message.Defer();
						} else {
						
							bool isLastMessage = (message.Properties["isLastMessageInSession"].ToString() == "true");
							// Remove message from queue
							message.Complete();
							
							if (isLastMessage)
							{
								Console.WriteLine("All done with this session!");
								break;
							}
						}
					}
					catch (Exception ex)
					{
						Console.WriteLine(ex.Message);
						// Indicate a problem, unlock message in queue
						message.Abandon();
					}
				}
			}
		}
	}
}