<Query Kind="Program">
  <Reference>&lt;RuntimeDirectory&gt;\System.Runtime.Serialization.dll</Reference>
  <Reference>C:\Utils\LINQPad\References\Azure SDK 1.6\Microsoft.ServiceBus.dll</Reference>
  <Namespace>Microsoft.ServiceBus</Namespace>
  <Namespace>Microsoft.ServiceBus.Messaging</Namespace>
</Query>

void Main()
{
	#region "Secret Stuff"
		string issuer = "{ACSIssuer}";
		string key = "{ACSIssuerKey}";
	#endregion

	TokenProvider tP = TokenProvider.CreateSharedSecretTokenProvider(issuer, key);
	Uri uri = ServiceBusEnvironment.CreateServiceUri("sb", "{ServiceBusNamespaceName}", string.Empty);
	NamespaceManager namespaceManager = new NamespaceManager(uri, tP);
	
	string endPointName = "TestSessionQueue";
	int numberOfMessagesToSend = 5;
	string sessionId = Guid.NewGuid().ToString();
	MessagingFactory factory = MessagingFactory.Create(namespaceManager.Address, namespaceManager.Settings.TokenProvider);
	MessageSender sender = factory.CreateMessageSender(endPointName);

	for (int count = 0; count < numberOfMessagesToSend; count++ )
	{
		BrokeredMessage message = new BrokeredMessage("Test message ");
	
		// Set some additional custom app-specific properties
		message.Properties["MessageCount"] = count;
		message.SessionId = sessionId;
		
		if (count == numberOfMessagesToSend -1){
			message.Properties["isLastMessageInSession"] = "true";
		} else {
			message.Properties["isLastMessageInSession"] = "false";
		}
	
		// Send message to the queue
		sender.Send(message);
	}
	Console.Write("Message(s) sent.");
}